#[cfg(test)]
mod tests {
    use std::time::Duration;
    use std::error::Error;
    use std::thread;
    use rpi_embedded::uart::{Parity, Uart};
    #[test]
//    fn it_works() {
//	      let mut x = 1;
//        println!("{:?}",assert_eq!(2 + 2, 4));
//	      while (x == 1){
//	    }
//    }
    fn uart_test ()-> Result<(), Box<dyn Error>> {
//	We send a message from the raspberry to the raspberry to be sure that uart is working - for that we need a wire between Tx and Rx
        let mut buffer = [0u8; 1];
        let mut test = [59u8;1]; //59 is "O" if we do the conversion
        let mut uart = Uart::new(9600, Parity::None, 8, 1)?;

	    uart.write(String::from("O")).unwrap();
    // Configure read() to block until at least 1 byte is received.
    	uart.set_read_mode(1, Duration::default())?;
	if (uart.read_bytes(&mut buffer)? > 0) & (buffer != [10u8;1]){
	    println!("{:?}", assert_eq!(buffer,test));
	}
	Ok(())
    }
}

use std::error::Error;
use std::time::Duration;
use std::thread;
use rpi_embedded::uart::{Parity, Uart};


struct GpsData {
    Uart_ : rpi_embedded::uart::Uart,
    id    : String,
    time  : String,
    lat   : String,
    long  : String,
    nbSat : String,
    hdop  : String,
    alti  : String,
}

impl GpsData {
    fn getData(&mut self) -> Result<(), Box<dyn Error>>  {
        let mut condition : bool = true;
        let mut buffer = [1u8; 1];

        let mut vec_of_u8:Vec<u8>= Vec::new();
        println!("Start getting data");
        let mut ite:u32 = 0;
        while condition {
            // Fill the buffer variable with any incoming data.
            if self.Uart_.read_bytes(&mut buffer)? > 0 {
                vec_of_u8.push(buffer[0]);
 
                if buffer[0] == 10{
                    condition = false;
                    let string_utf8_result = String::from_utf8(vec_of_u8.clone()).unwrap();
                    let tokens:Vec<&str>=string_utf8_result.split(",").collect();
                    if tokens[0] == "$GPGGA"{
                        self.id    = tokens[0].to_string();
                        self.time  = tokens[1].to_string();
                        self.lat   = tokens[2].to_string();
                        self.long  = tokens[4].to_string();
                        self.nbSat = tokens[6].to_string();
                        self.hdop  = tokens[7].to_string();
                        self.alti  = tokens[8].to_string();
                    }
                }
                if ite > 500 {
                    println!("Sorry annot rad data");
                    condition = false;
                }
            }
            ite = ite+1;
        }
        Ok(())
    }
    fn init (&mut self) -> Result<(), Box<dyn Error>> {
        self.Uart_ = Uart::new(9600, Parity::None, 8, 1)?;
        self.Uart_.set_read_mode(1, Duration::default())?;
        Ok(())
    }
}

fn main() -> Result<(), Box<dyn Error>> {

    let mut data= GpsData {
        Uart_ : Uart::new(9600, Parity::None, 8, 1)?,
        id    : "0".to_string(),
        time  : "0".to_string(),
        lat   : "0".to_string(),
        long  : "0".to_string(),
        nbSat : "0".to_string(),
        hdop  : "0".to_string(),
        alti  : "0".to_string(),
    };

    data.init();
    // println!("Start");
    loop {
        data.getData();
        println!("lat : {} N", data.lat);
        println!("long : {} W", data.long);
        thread::sleep(Duration::from_millis(1000));
    }

    Ok(())
}
